   title	Direct3d Basis - Siekmanski 2005
     .686p 
      .model flat, C, stdcall 
       option casemap :none 
      .xmm 

   include \masm32\include\windows.inc
   include \masm32\include\kernel32.inc
   include \masm32\include\user32.inc
   include \masm32\include\winmm.inc
   include \masm32\include\gdi32.inc

   include \masm32\d3dx9includes\dx9macros.inc
   include \masm32\d3dx9includes\d3dx9.inc


   includelib \masm32\d3dx9libs\kernel32.lib
   includelib \masm32\d3dx9libs\user32.lib
   includelib \masm32\d3dx9libs\winmm.lib
   includelib \masm32\d3dx9libs\gdi32.lib

   includelib \masm32\d3dx9libs\advapi32.lib
   includelib \masm32\d3dx9libs\msvcrt.lib
   includelib \masm32\d3dx9libs\uuid.lib

   includelib \masm32\d3dx9libs\d3d9.lib
   includelib \masm32\d3dx9libs\d3dx9.lib

.const

SMILEY_ICON    equ 200
Solid_Texture  equ 500
Alpha_Texture  equ 501

D3DFVF_MODELVERTEX  equ (D3DFVF_XYZ or D3DFVF_NORMAL or D3DFVF_DIFFUSE or D3DFVF_TEX1)

MODELVERTEX struct
   position D3DXVECTOR3 <?>
   normal   D3DXVECTOR3 <?>
   color    D3DCOLOR ?
   tu       REAL4 ?                    
   tv       REAL4 ?                    
MODELVERTEX ends

.data?

hInst        dd ?
hWnd         dd ? 
d3d_timer    dd ?
WndProc_ptr  dd ?
WndProcF_ptr dd ?

String_buffer db 256 dup (?)

.data

ClassName   db  'Direct3d Basis',0
AppName     db  'Direct3D Basis - Siekmanski',0

align 16    ;keep matrices 16-byte aligned as preferred by P4 cpu's.
matRotatie   D3DXMATRIXA16 <0>
matWorld     D3DXMATRIXA16 <0>
matView      D3DXMATRIXA16 <0>
matProj      D3DXMATRIXA16 <0>

d3ddm        D3DDISPLAYMODE <0>
d3dpp        D3DPRESENT_PARAMETERS <0>
d3dcaps      D3DCAPS9 <0>

eyevector    D3DXVECTOR3 < 0.0, 0.0,-4.0 >
lookatvector D3DXVECTOR3 < 0.0, 0.0, 0.0 >
upvector     D3DXVECTOR3 < 0.0, 1.0, 0.0 >

WindowRect   RECT <0>

g_pD3D       LPDIRECT3D9             NULL	
g_pD3DDevice LPDIRECT3DDEVICE9       NULL

g_pVBModel   LPDIRECT3DVERTEXBUFFER9 NULL
g_pTexture1  LPDIRECT3DTEXTURE9      NULL
g_pVBModel2  LPDIRECT3DVERTEXBUFFER9 NULL
g_pTexture2  LPDIRECT3DTEXTURE9      NULL

m_bWindowed     dd TRUE ;FALSE ;TRUE

Window_Width    dd 640
Window_Height   dd 480

m_bMinimized    dd FALSE
m_bMaximized    dd FALSE

x_Angle         REAL4 0.0
y_Angle         REAL4 0.0
z_Angle         REAL4 0.0
x_Position      REAL4 0.0
y_Position      REAL4 0.0
z_Position      REAL4 0.0

x_RotationSpeed REAL4 0.0000
y_RotationSpeed REAL4 0.0006
z_RotationSpeed REAL4 0.0000


g_pFont      LPD3DXFONT NULL ; system font
d3dadapter   D3DADAPTER_IDENTIFIER9 <>
Vertex_types db 36 dup (0)
fLastTime    dd 0
dwFrames     dd 0
Stat_Str     db 32 dup (0)


align 4

Num_Coordinates dd 6

solidSquare MODELVERTEX <{-1.0, 1.0, 1.0},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(255,255,255,255), 0.0, 0.0>
            MODELVERTEX <{ 1.0,-1.0, 1.0},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(255,255,255,255), 1.0, 1.0>
            MODELVERTEX <{-1.0,-1.0, 1.0},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(255,255,255,255), 0.0, 1.0>
            MODELVERTEX <{-1.0, 1.0, 1.0},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(255,255,255,255), 0.0, 0.0>
            MODELVERTEX <{ 1.0, 1.0, 1.0},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(255,255,255,255), 1.0, 0.0>
            MODELVERTEX <{ 1.0,-1.0, 1.0},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(255,255,255,255), 1.0, 1.0>


alpha_value equ 150

alphaSquare MODELVERTEX <{-0.8, 0.8, 0.2},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(alpha_value,255,255,255), 0.0, 0.0>
            MODELVERTEX <{ 0.8,-0.8, 0.2},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(alpha_value,255,255,255), 1.0, 1.0>
            MODELVERTEX <{-0.8,-0.8, 0.2},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(alpha_value,255,255,255), 0.0, 1.0>
            MODELVERTEX <{-0.8, 0.8, 0.2},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(alpha_value,255,255,255), 0.0, 0.0>
            MODELVERTEX <{ 0.8, 0.8, 0.2},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(alpha_value,255,255,255), 1.0, 0.0>
            MODELVERTEX <{ 0.8,-0.8, 0.2},{ 0.0, 0.0,-1.0},D3DCOLOR_ARGB(alpha_value,255,255,255), 1.0, 1.0>

.code

Init_D3DPresentParameters proc
   invoke   RtlZeroMemory,addr d3dpp,sizeof d3dpp
   mov      d3dpp.Windowed,TRUE
   mov      eax,hWnd
   mov      d3dpp.hDeviceWindow,eax
   mov      d3dpp.SwapEffect,D3DSWAPEFFECT_DISCARD
   mov      d3dpp.BackBufferFormat,D3DFMT_UNKNOWN
   mov      d3dpp.EnableAutoDepthStencil,TRUE
   mov      d3dpp.AutoDepthStencilFormat,D3DFMT_D16
   mov      d3dpp.PresentationInterval,D3DPRESENT_INTERVAL_ONE

   .if (!m_bWindowed)
       mov      d3dpp.Windowed,FALSE
       mov      d3dpp.BackBufferCount,1
       mov      eax,d3ddm.dx_Width
       mov      d3dpp.BackBufferWidth,eax
       mov      eax,d3ddm.dx_Height
       mov      d3dpp.BackBufferHeight,eax
       mov      eax,d3ddm.Format
       mov      d3dpp.BackBufferFormat,eax
       mov      eax,d3ddm.RefreshRate
       mov      d3dpp.FullScreen_RefreshRateInHz,eax
;       mov      d3dpp.PresentationInterval,D3DPRESENT_INTERVAL_DEFAULT
   .endif
   ret
Init_D3DPresentParameters endp

Init_D3dPerspectiveMatrix proc
 LOCAL fpAspectRatio:REAL4
   ; calculate aspectratio
   fild      d3dpp.BackBufferWidth
   fidiv     d3dpp.BackBufferHeight
   fstp     fpAspectRatio
   invoke   D3DXMatrixPerspectiveFovLH,addr matProj,FLOAT_(D3DX_PI_QUARTER),fpAspectRatio,FLOAT_(1.0),FLOAT_(100.0)
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetTransform,D3DTS_PROJECTION,addr matProj
   ret
Init_D3dPerspectiveMatrix endp


Init_D3dSystemFont proc
LOCAL hdc:DWORD
   SAFE_RELEASE g_pFont		
   invoke   GetDC,NULL
   mov      hdc,eax
   invoke   GetDeviceCaps,hdc,LOGPIXELSY
   mov      ecx,10 ; calculate font height
   mul      ecx
   mov      ecx,72
   xor      edx,edx
   div      ecx
   neg      eax
   invoke   D3DXCreateFont,g_pD3DDevice,eax,0,FW_BOLD,0,FALSE,DEFAULT_CHARSET,\
                           OUT_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_DONTCARE,\ 
                           TEXT_("System"),addr g_pFont
   invoke   ReleaseDC,NULL,hdc
   ret
Init_D3dSystemFont endp


InitD3d proc hwnd:DWORD
   invoke   Direct3DCreate9,D3D_SDK_VERSION
   if_FAILED
      return E_FAIL
   .endif
   mov      g_pD3D,eax

	coinvoke	g_pD3D,IDirect3D9,GetAdapterIdentifier,D3DADAPTER_DEFAULT,0,addr d3dadapter
	if_FAILED
		return	E_FAIL
	.endif

   coinvoke g_pD3D,IDirect3D9,GetAdapterDisplayMode,D3DADAPTER_DEFAULT,addr d3ddm
   if_FAILED
      return E_FAIL
   .endif

   coinvoke g_pD3D,IDirect3D9,GetDeviceCaps,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,addr d3dcaps
   if_FAILED
      return E_FAIL
   .endif

   invoke   Init_D3DPresentParameters


   mov      eax,d3dcaps.DevCaps
   test     eax,D3DDEVCAPS_HWTRANSFORMANDLIGHT
   .if (eax != 0)
      mov      eax,d3dcaps.DevCaps
      test     eax,D3DDEVCAPS_PUREDEVICE
       .if (eax != 0)
          invoke   lstrcpy,addr Vertex_types,TEXT_("HAL Pure hardware vertex processing")
          mov      eax,D3DCREATE_HARDWARE_VERTEXPROCESSING or D3DCREATE_PUREDEVICE
       .else
          invoke   lstrcpy,addr Vertex_types,TEXT_("HAL Hardware vertex processing")
          mov      eax,D3DCREATE_HARDWARE_VERTEXPROCESSING
       .endif
   .else
      invoke   lstrcpy,addr Vertex_types,TEXT_("HAL Software vertex processing")
      mov      eax,D3DCREATE_SOFTWARE_VERTEXPROCESSING
   .endif

   coinvoke g_pD3D,IDirect3D9,CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hwnd,eax,addr d3dpp,addr g_pD3DDevice
   if_FAILED
      return E_FAIL
   .endif

   invoke   Init_D3dPerspectiveMatrix

   invoke   Init_D3dSystemFont
   mov      eax,S_OK
   ret
InitD3d endp


InitGeometry proc	
 LOCAL VertexBuffer_Ptr:DWORD




;   invoke   D3DXCreateTextureFromResource,g_pD3DDevice,NULL,Solid_Texture,addr g_pTexture1
;   if_FAILED
;      return E_FAIL
;   .endif


   invoke   D3DXCreateTextureFromFileExA,g_pD3DDevice,TEXT_("picture.png"),D3DX_DEFAULT,D3DX_DEFAULT,D3DX_DEFAULT,0,D3DFMT_UNKNOWN,D3DPOOL_DEFAULT,D3DX_DEFAULT,D3DX_DEFAULT,0,NULL,NULL,addr g_pTexture1
   if_FAILED
      return E_FAIL
   .endif

	
   mov      eax,(sizeof MODELVERTEX)
   mul      Num_Coordinates
   coinvoke g_pD3DDevice,IDirect3DDevice9,CreateVertexBuffer,eax,0,D3DFVF_MODELVERTEX,D3DPOOL_DEFAULT,addr g_pVBModel,NULL 
   if_FAILED
      return E_FAIL
   .endif

   coinvoke g_pVBModel,IDirect3DVertexBuffer9,Lock,0,0,addr VertexBuffer_Ptr,0
   if_FAILED
      return E_FAIL
   .endif
   push     edi
   push     esi
   cld
   lea      esi,solidSquare
   mov      edi,VertexBuffer_Ptr
   mov      eax,(sizeof MODELVERTEX)
   mul      Num_Coordinates
   mov      ecx,eax
   shr      ecx,2
   rep      movsd
   pop      esi
   pop      edi
   coinvoke g_pVBModel,IDirect3DVertexBuffer9,Unlock

   invoke   D3DXCreateTextureFromResource,g_pD3DDevice,NULL,Alpha_Texture,addr g_pTexture2
   if_FAILED
      return E_FAIL
   .endif
   mov      eax,(sizeof MODELVERTEX)
   mul      Num_Coordinates
   coinvoke g_pD3DDevice,IDirect3DDevice9,CreateVertexBuffer,eax,0,D3DFVF_MODELVERTEX,D3DPOOL_DEFAULT,addr g_pVBModel2,NULL 
   if_FAILED
      return E_FAIL
   .endif

   coinvoke g_pVBModel2,IDirect3DVertexBuffer9,Lock,0,0,addr VertexBuffer_Ptr,0
   if_FAILED
      return E_FAIL
   .endif
   push     edi
   push     esi
   cld
   lea      esi,alphaSquare
   mov      edi,VertexBuffer_Ptr
   mov      eax,(sizeof MODELVERTEX)
   mul      Num_Coordinates
   mov      ecx,eax
   shr      ecx,2
   rep      movsd
   pop      esi
   pop      edi
   coinvoke g_pVBModel2,IDirect3DVertexBuffer9,Unlock

   coinvoke g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_LIGHTING,FALSE
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_ZENABLE,TRUE
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_CULLMODE,D3DCULL_NONE

   coinvoke g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_ALPHABLENDENABLE,TRUE
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_SRCBLEND,D3DBLEND_SRCALPHA
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA

   coinvoke g_pD3DDevice,IDirect3DDevice9,SetSamplerState,0,D3DSAMP_MINFILTER,D3DTEXF_LINEAR
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetSamplerState,0,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR

   coinvoke g_pD3DDevice,IDirect3DDevice9,SetTextureStageState,0,D3DTSS_ALPHAARG1,D3DTA_DIFFUSE

   mov      eax,S_OK
   ret
InitGeometry endp


ObjectToWorldTransformation proc ScaleX:FLOAT,ScaleY:FLOAT,ScaleZ:FLOAT,
                                 RotateX:FLOAT,RotateY:FLOAT,RotateZ:FLOAT, 
                                 TranslateX:FLOAT,TranslateY:FLOAT,TranslateZ:FLOAT

align 16 ;keep matrices 16-byte aligned as preferred by P4 cpu's.
 LOCAL WorldMatrix:D3DXMATRIXA16
 LOCAL TransformMatrix:D3DXMATRIXA16

   D3DXMatrixIdentity(WorldMatrix)

   invoke   D3DXMatrixScaling,addr TransformMatrix,ScaleX,ScaleY,ScaleZ
   invoke   D3DXMatrixMultiply,addr WorldMatrix,addr WorldMatrix,addr TransformMatrix

   invoke   D3DXMatrixRotationYawPitchRoll,addr TransformMatrix,RotateY,RotateX,RotateZ
   invoke   D3DXMatrixMultiply,addr WorldMatrix,addr WorldMatrix,addr TransformMatrix

   invoke   D3DXMatrixTranslation,addr TransformMatrix,TranslateX,TranslateY,TranslateZ
   invoke   D3DXMatrixMultiply,addr WorldMatrix,addr WorldMatrix,addr TransformMatrix

   coinvoke g_pD3DDevice,IDirect3DDevice9,SetTransform,D3DTS_WORLD,addr WorldMatrix
   ret
ObjectToWorldTransformation endp


Draw_model proc
   fild     d3d_timer
   fmul     x_RotationSpeed
   fstp     x_Angle
   fild     d3d_timer
   fmul     y_RotationSpeed
   fstp     y_Angle
   fild     d3d_timer
   fmul     z_RotationSpeed
   fstp     z_Angle

   invoke   ObjectToWorldTransformation,FLOAT_(1.0),FLOAT_(1.0),FLOAT_(1.0), ; Scaling 
                                        x_Angle,y_Angle,z_Angle,             ; Rotation
                                        x_Position,y_Position,z_Position     ; Translations

   coinvoke g_pD3DDevice,IDirect3DDevice9,SetFVF,D3DFVF_MODELVERTEX

   coinvoke g_pD3DDevice,IDirect3DDevice9,SetStreamSource,0,g_pVBModel,0,sizeof MODELVERTEX
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetTexture,0,g_pTexture1
   coinvoke g_pD3DDevice,IDirect3DDevice9,DrawPrimitive,D3DPT_TRIANGLELIST,0,2
 
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetStreamSource,0,g_pVBModel2,0,sizeof MODELVERTEX
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetTexture,0,g_pTexture2
   coinvoke g_pD3DDevice,IDirect3DDevice9,DrawPrimitive,D3DPT_TRIANGLELIST,0,2
   ret
Draw_model endp

ReleaseDeviceObjects proc
   SAFE_RELEASE g_pTexture2
   SAFE_RELEASE g_pVBModel2
   SAFE_RELEASE g_pTexture1
   SAFE_RELEASE g_pVBModel
   ret
ReleaseDeviceObjects endp

StopD3d proc
   invoke   ReleaseDeviceObjects
   SAFE_RELEASE g_pFont
   SAFE_RELEASE g_pD3DDevice
   SAFE_RELEASE g_pD3D
   ret
StopD3d	endp

Reset3DEnvironment proc
   invoke   ReleaseDeviceObjects
   SAFE_RELEASE g_pFont
   invoke   Init_D3DPresentParameters

   coinvoke g_pD3DDevice,IDirect3DDevice9,Reset,addr d3dpp
   .if (eax != D3D_OK)
       ret
   .endif

   invoke   Init_D3dSystemFont
   invoke   Init_D3dPerspectiveMatrix
   invoke   InitGeometry
   ret
Reset3DEnvironment endp

FrameStats proc
LOCAL	rc:RECT
LOCAL  dwFraction:DWORD

   inc      dwFrames
   mov      eax,d3d_timer
   sub      eax,fLastTime
   .if	(eax > 1000)
      sub      eax,1000
      mov      dwFraction,eax
      fld      dwFraction
      fmul     FLOAT_(65.536) ;*65536/1000 sec.
      fstp     dwFraction			
      invoke   wsprintf,addr Stat_Str,TEXT_("Fps: %d.%03d  (%d x %d)"),dwFrames,dwFraction,d3dpp.BackBufferWidth,d3dpp.BackBufferHeight
      mov      eax,d3d_timer
      mov      fLastTime,eax
      mov      dwFrames,-1
   .endif

   invoke   SetRect,addr rc,2,0,0,0
   coinvoke g_pFont,ID3DXFont,DrawTextA,NULL,addr d3dadapter.Description,-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,0)
   invoke   SetRect,addr rc,2,15,0,0
   coinvoke g_pFont,ID3DXFont,DrawTextA,NULL,addr Stat_Str,-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,0)
   invoke   SetRect,addr rc,2,15*2,0,0
   coinvoke g_pFont,ID3DXFont,DrawTextA,NULL,addr Vertex_types,-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,0)
   invoke   SetRect,addr rc,2,15*4,0,0
   coinvoke g_pFont,ID3DXFont,DrawTextA,NULL,TEXT_("F1:   Toggle fullscreen",13,10,"Esc: End"),-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(0,255,0)
   invoke   SetRect,addr rc,2,15*6,0,0
   coinvoke g_pFont,ID3DXFont,DrawTextA,NULL,TEXT_("Cursor keys PgUp and PgDn to move Object."),-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(0,255,0)

  ret
FrameStats endp


RenderD3d proc
   coinvoke g_pD3DDevice,IDirect3DDevice9,TestCooperativeLevel
   cmp      eax,D3DERR_DEVICELOST
   je       Render_nothing
   cmp      eax,D3DERR_DEVICENOTRESET
   jne      Start_RenderD3d
   invoke   Reset3DEnvironment
Start_RenderD3d:

   coinvoke g_pD3DDevice,IDirect3DDevice9,Clear,0,NULL,D3DCLEAR_TARGET or D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,216),FLOAT_(1.0),0
   invoke   timeGetTime
   mov      d3d_timer,eax

   invoke   D3DXMatrixLookAtLH,addr matView,addr eyevector,addr lookatvector,addr upvector
   coinvoke g_pD3DDevice,IDirect3DDevice9,SetTransform,D3DTS_VIEW,addr matView

   coinvoke g_pD3DDevice,IDirect3DDevice9,BeginScene

   invoke   Draw_model

   invoke   FrameStats

   coinvoke g_pD3DDevice,IDirect3DDevice9,EndScene

   coinvoke g_pD3DDevice,IDirect3DDevice9,Present,NULL,NULL,NULL,NULL
Render_nothing:
   ret
RenderD3d endp

ToggleFullScreen proc
   .if (!m_bWindowed)
       invoke   SetWindowLong,hWnd,GWL_EXSTYLE,WS_EX_CLIENTEDGE
       invoke   SetWindowLong,hWnd,GWL_STYLE,WS_OVERLAPPEDWINDOW
       invoke   SetWindowLong,hWnd,GWL_WNDPROC,WndProc_ptr
       mov      eax,WindowRect.right
       sub      eax,WindowRect.left
       mov      ecx,WindowRect.bottom
       sub      ecx,WindowRect.top
       invoke   SetWindowPos,hWnd,HWND_NOTOPMOST,WindowRect.left,WindowRect.top,eax,ecx,SWP_SHOWWINDOW
       mov      m_bWindowed,TRUE
   .else
		invoke   GetWindowRect,hWnd,addr WindowRect
       invoke   SetWindowLong,hWnd,GWL_EXSTYLE,WS_EX_TOPMOST
       invoke   SetWindowLong,hWnd,GWL_STYLE,WS_POPUP
       invoke   SetWindowLong,hWnd,GWL_WNDPROC,WndProcF_ptr
       mov      m_bWindowed,FALSE
   .endif
   invoke   Reset3DEnvironment
   ret
ToggleFullScreen endp

Move_object proc
   invoke   GetAsyncKeyState,VK_LEFT
   test     ax,ax
   jns      if_right
   fld      x_Position
   fsub     FLOAT_(0.02)
   fstp     x_Position
if_right:
   invoke   GetAsyncKeyState,VK_RIGHT
   test     ax,ax
   jns      if_down
   fld      x_Position
   fadd     FLOAT_(0.02)
   fstp     x_Position
if_down:
	invoke   GetAsyncKeyState,VK_NEXT
   test     ax,ax
   jns      if_up
   fld      y_Position
   fsub     FLOAT_(0.02)
   fstp     y_Position
if_up:
	invoke   GetAsyncKeyState,VK_PRIOR
   test     ax,ax
   jns      if_back
   fld      y_Position
   fadd     FLOAT_(0.02)
   fstp     y_Position
if_back:
	invoke   GetAsyncKeyState,VK_DOWN
   test     ax,ax
   jns      if_front
   fld      z_Position
   fsub     FLOAT_(0.02)
   fstp     z_Position
if_front:
	invoke   GetAsyncKeyState,VK_UP
   test     ax,ax
   jns      if_end
   fld      z_Position
   fadd     FLOAT_(0.02)
   fstp     z_Position
if_end:
   ret
Move_object endp


WndProc proc hwnd:DWORD,wMsg:DWORD,wParam:DWORD,lParam:DWORD
   .if wMsg == WM_DESTROY
       invoke   PostQuitMessage,NULL
       return   0

   .elseif wMsg == WM_SIZE   ; check if window size has changed
       .if wParam == SIZE_MINIMIZED
           mov      m_bMinimized,TRUE
           mov      m_bMaximized,FALSE
       .elseif wParam == SIZE_MAXIMIZED
           invoke   Reset3DEnvironment
           mov      m_bMinimized,FALSE
           mov      m_bMaximized,TRUE
       .elseif wParam == SIZE_RESTORED
           .if (m_bMaximized)
               invoke   Reset3DEnvironment
               mov      m_bMaximized,FALSE
           .elseif (m_bMinimized)
               invoke   Reset3DEnvironment
               mov      m_bMinimized,FALSE
           .endif
       .endif
       return   0

   .elseif wMsg == WM_EXITSIZEMOVE
       invoke   Reset3DEnvironment
       return   0

   .elseif wMsg == WM_PAINT
       invoke   ValidateRect,hwnd,NULL
       return   0

   .elseif wMsg == WM_KEYDOWN
       .if wParam == VK_ESCAPE
           invoke   PostQuitMessage,WM_QUIT
           return   0
       .elseif wParam == VK_F1
           invoke   ToggleFullScreen
       .endif
       return   0

   .else
       invoke   DefWindowProc,hwnd,wMsg,wParam,lParam
       ret
   .endif
WndProc endp

WndProcfullscreen proc hwnd:DWORD,wMsg:DWORD,wParam:DWORD,lParam:DWORD
   .if wMsg == WM_DESTROY
       invoke   PostQuitMessage,NULL
       return   0

   .elseif wMsg == WM_PAINT
       invoke   ValidateRect,hwnd,NULL
       return   0

   .elseif wMsg == WM_SETCURSOR
       invoke   SetCursor,NULL ; turn off cursor			
       return   TRUE

   .elseif wMsg == WM_KEYDOWN
       .if wParam == VK_ESCAPE
           invoke   PostQuitMessage,WM_QUIT
           return   0
       .elseif wParam == VK_F1
           invoke   ToggleFullScreen
       .endif
       return   0

   .else
       invoke   DefWindowProc,hwnd,wMsg,wParam,lParam
       ret
   .endif
WndProcfullscreen endp


WinMain proc hinst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
 LOCAL wc:WNDCLASSEX
 LOCAL msg:MSG

   mov      wc.cbSize,sizeof WNDCLASSEX
   mov      wc.style,CS_HREDRAW or CS_VREDRAW or CS_OWNDC
   mov      eax,offset WndProcfullscreen
   mov      WndProcF_ptr,eax
   mov      eax,offset WndProc
   mov      WndProc_ptr,eax
   mov      wc.lpfnWndProc,eax
   mov      wc.cbClsExtra,NULL
   mov      wc.cbWndExtra,NULL
   mov      eax,hInst
   mov      wc.hInstance,eax
   invoke   GetStockObject,BLACK_BRUSH
   mov      wc.hbrBackground,eax
   mov      wc.lpszMenuName,NULL
   mov      wc.lpszClassName,offset ClassName
   invoke   LoadIcon,hInst,SMILEY_ICON
   mov      wc.hIcon,eax
   mov      wc.hIconSm,eax
   invoke   LoadCursor,NULL,IDC_ARROW
   mov      wc.hCursor,eax
   invoke   RegisterClassEx,addr wc

   invoke   SetRect,addr WindowRect,0,0,Window_Width,Window_Height
   invoke   AdjustWindowRectEx,addr WindowRect,WS_OVERLAPPEDWINDOW,FALSE,WS_EX_CLIENTEDGE

   mov      eax,WindowRect.left
   sub      WindowRect.right, eax
   mov      eax,WindowRect.top
   sub      WindowRect.bottom, eax

   invoke   GetSystemMetrics,SM_CXSCREEN
   sub      eax,WindowRect.right
   shr      eax,1
   mov      WindowRect.left,eax
   invoke   GetSystemMetrics,SM_CYSCREEN
   sub      eax,WindowRect.bottom
   shr      eax,1
   mov      WindowRect.top,eax

   invoke   GetDesktopWindow
   invoke   CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr AppName,WS_OVERLAPPEDWINDOW, \
                           WindowRect.left,WindowRect.top,WindowRect.right,WindowRect.bottom,eax,NULL,hInst,NULL
   mov      hWnd,eax

   .if (!m_bWindowed)
       invoke   GetWindowRect,hWnd,addr WindowRect
       invoke   SetWindowLong,hWnd,GWL_EXSTYLE,WS_EX_TOPMOST
       invoke   SetWindowLong,hWnd,GWL_STYLE,WS_POPUP
       invoke   SetWindowLong,hWnd,GWL_WNDPROC,WndProcF_ptr
	.endif

;   mov eax,-1
;   invoke   wsprintf,addr String_buffer,TEXT_("Hex: %08x",13,10,"Dec. sign.: %d",13,10,"Dec. usign.: %u"),eax,eax,eax
;   invoke   MessageBox,NULL,addr String_buffer,TEXT_("DX_Info"),MB_ICONINFORMATION

   invoke   InitD3d,hWnd 
   if_FAILED
      invoke   MessageBox,hWnd,TEXT_("Unable to create Direct3D Object"),TEXT_("DX_Info"),MB_ICONERROR
      jmp   EndD3d
   .endif

   invoke   InitGeometry
   if_FAILED
      invoke   MessageBox,hWnd,TEXT_("Unable to create Geometry"),TEXT_("DX_Info"),MB_ICONERROR
      jmp   EndD3d
   .endif

   invoke   ShowWindow,hWnd,SW_SHOWNORMAL
   invoke   UpdateWindow,hWnd

   invoke   RtlZeroMemory,addr msg,sizeof msg

   .while ( msg.message != WM_QUIT )
      invoke   PeekMessage,addr msg,NULL,0,0,PM_REMOVE
      .if eax != 0
         invoke   TranslateMessage,addr msg
         invoke   DispatchMessage,addr msg
      .else
         invoke   Move_object 
         invoke   RenderD3d
      .endif
   .endw

EndD3d:
   invoke   StopD3d 
   invoke   UnregisterClass,addr ClassName,wc.hInstance

   mov      eax,msg.wParam
   ret
WinMain endp


start:
   invoke   GetModuleHandle,NULL
   mov      hInst,eax

   invoke   WinMain,hInst,NULL,NULL,SW_SHOWDEFAULT
   invoke   ExitProcess,eax
end start
